'*******************************************************************************

'* Barix Barionet Testprogram for RDI | 4AIN-2Rel,4DIN-4DOUT,RS-232(prot.RS-232)

'*******************************************************************************

'* Written by Dragan Hintermann, 14. Jan. 2004 Copyright Barix AG, Switzerland  

'*******************************************************************************

'* Changes by M.W. to extend funtionality and correct bugs                      

'* 	   20.12.07 goto Bugfix in test Ain 3+4	      				

'*	   	    added setup write to get back to defaults			

'*		    added RS422 testing	     	     				

'*		    various timing improvements					

'*		    System accquires fix IP 192.168.2.222 from attached GU therefore ARP trick is no longer required

'*		    	   	     	    		       		   	     

'*******************************************************************************

    'DIM set$ (256)

    DIM cr$ (4) 



    ID$=SPRINTF$("IP=%A",1)+SPRINTF$(" MAC=%1H FW V%V",0)	'Identification

    e = 0							'error counter

    cr$ = chr$(13)+chr$(10)					'CR LF

    tio = 100							'time delay before testing Din pin after switching Dout state

    tr = 1000							'time delay before testing Din pin after switching relay state



' first check if second port is in RS422 mode if not change and reboot

    OPEN "STP:0" AS 3 

    READ 3,set$ 

    if midget(set$,34,1)=8 then goto 9

    midset set$,34,1,8						' set RS422 MODE

    Write 3,set$,256

    CLOSE 3 

    lock 2							' reboot



9   close 3





' check RS232 using loopback resistors

1   p$ = "COM:9600,N,8,1,NON:1"					'Use RS-232 for test and reporting parameters are ignored

    OPEN p$ AS 1						'Open COM port

    w$ = "Test BARIONET V1.0 "+ID$+cr$				'Compose Text and ID

    SYSLOG w$							'Write ID to SYSLOG

111

    READ 1,s$							' JR: first need to empty buffer !

    If lastlen(1)>0 Then GoTo 111

    								' might be clogged from earlier test.

    WRITE 1, w$, 0						'Write ID to COM

    DELAY 100							'Delay before reading

    READ 1, s$

    IF s$=w$ THEN GOTO 5					'Test RS422

    w$ = "@@@ ERROR @@@ RS-232 Read not OK! Loopback maybe not connected (Pin2-Pin3)! READ>"+s$+"<"+cr$

    gosub 1000	    	       	    	    	     	       ' print screen and syslog inc error count /#



' check RS422 using loopback

5   p$ = "COM::2"						'test RS422 parameters are ignored

    OPEN p$ AS 2						'Open COM port

    w$ = "Test BARIONET V1.0 RS422"+cr$				'Compose Text and ID

112

    READ 2,s$							' JR: first need to empty buffer !

    If lastlen(2)>0 Then GoTo 112

    								' might be clogged from earlier test.

    WRITE 2, w$, 0						'Write ID to COM

    DELAY 100							'Delay before reading

    READ 2, s$

    close 2

    IF s$=w$ THEN GOTO 10					'Test analog, Relais and so on 

    w$ = "@@@ ERROR @@@ RS-422 Read not OK! Loopback fault! READ>"+s$+"<"+cr$

    gosub 1000							' print screen and syslog inc error count /#









10  'Testing Ain 1 + 2 and Rel 1 NC + NO * * * * * * * * * * * * * * * * * * * *

    a = IOSTATE(501)	'Check analog value

    d = IOSTATE(201)	'Check digital state

    IF d = 0 THEN w$ = "@@@ ERROR @@@ Input 1 or Relay 1 (NC) not connected!"+cr$: gosub 1000: GOTO 15			'Error messages and count errors

    IF a < 170 THEN w$ = "@@@ ERROR @@@ Input 1 Analog Value:"+STR$(a)+" too low! (170..190)"+cr$: gosub 1000		'Error messages and count errors

    IF a > 190 THEN w$ = "@@@ ERROR @@@ Input 1 Analog Value:"+STR$(a)+" too high! (170..190)"+cr$: gosub 1000		'Error messages and count errors

    IOCTL 1, 1		'activate Relay 1

    DELAY tr		'Wait tr (time relay) for relay to open

    d = IOSTATE(201)	'Check digital state

    a = IOSTATE(501)	'Check analog value

    IF d  THEN w$ = "@@@ ERROR @@@ Relay 1 (NC) did not open!"+cr$: gosub 1000: GOTO 15					'Error messages and count errors

    IF a < 1018 THEN w$ = "@@@ ERROR @@@ Open Input 1 Analog Value:"+STR$(a)+" too low! (1018..1024)"+cr$: gosub 1000	'Error messages and count errors



15  a = IOSTATE(502)	'Check analog value

    d = IOSTATE(202)	'Check digital state

    IF d = 0 THEN w$ = "@@@ ERROR @@@ Input 2 or Relay 1 (NO) not connected!"+cr$: gosub 1000: GOTO 16			'Error messages and count errors

    IF a < 170 THEN w$ = "@@@ ERROR @@@ Input 2 Analog Value:"+STR$(a)+" too low! (170..190)"+cr$: gosub 1000		'Error messages and count errors

    IF a > 190 THEN w$ = "@@@ ERROR @@@ Input 2 Analog Value:"+STR$(a)+" too high! (170..190)"+cr$: gosub 1000		'Error messages and count errors

    IOCTL 1, 0		'deactivate Relay 1

    DELAY tr		'Wait tr (time relay) for relay to close

    d = IOSTATE(202)	'Check digital state

    a = IOSTATE(502)	'Check analog value

    IF d  THEN w$ = "@@@ ERROR @@@ Relay 1 (NO) did not open!"+cr$: gosub 1000: GOTO 16					'this was 15 but it should continue as for others MW

    IF a < 1018 THEN w$ = "@@@ ERROR @@@ Open Input 2 Analog Value:"+STR$(a)+" too low! (1018..1024)"+cr$: gosub 1000	'Error messages and count errors



16  'Testing Ain 3 + 4 and Rel 2 NC + NO * * * * * * * * * * * * * * * * * * * *

    a = IOSTATE(503)	'Check analog value

    d = IOSTATE(203)	'Check digital state

    IF d = 0 THEN w$ = "@@@ ERROR @@@ Input 3 or Relay 2 (NC) not connected!"+cr$: gosub 1000: GOTO 17			'Error messages and count errors

    IF a < 170 THEN w$ = "@@@ ERROR @@@ Input 3 Analog Value:"+STR$(a)+" too low! (170..190)"+cr$: gosub 1000		'Error messages and count errors

    IF a > 190 THEN w$ = "@@@ ERROR @@@ Input 3 Analog Value:"+STR$(a)+" too high! (170..190)"+cr$: gosub 1000		'Error messages and count errors

    IOCTL 2, 1		'activate Relay 2

    DELAY tr		'Wait tr (time relay) for relay to open

    d = IOSTATE(203)	'Check digital state

    a = IOSTATE(503)	'Check analog value

    IF d  THEN w$ = "@@@ ERROR @@@ Relay 2 (NC) did not open!"+cr$: gosub 1000: GOTO 17					'Error messages and count errors

    IF a < 1018 THEN w$ = "@@@ ERROR @@@ Open Input 3 Analog Value:"+STR$(a)+" too low! (1018..1024)"+cr$: gosub 1000	'Error messages and count errors



17  a = IOSTATE(504)	'Check analog value

    d = IOSTATE(204)	'Check digital state

    IF d = 0 THEN w$ = "@@@ ERROR @@@ Input 4 or Relay 2 (NO) not connected!"+cr$: gosub 1000: GOTO 20			'Error messages and count errors

    IF a < 170 THEN w$ = "@@@ ERROR @@@ Input 4 Analog Value:"+STR$(a)+" too low! (170..190)"+cr$: gosub 1000		'Error messages and count errors

    IF a > 190 THEN w$ = "@@@ ERROR @@@ Input 4 Analog Value:"+STR$(a)+" too high! (170..190)"+cr$: gosub 1000		'Error messages and count errors

    IOCTL 2, 0		'deactivate Relay 2

    DELAY tr		'Wait tr (time relay) for relay to close

    d = IOSTATE(204)	'Check digital state

    a = IOSTATE(504)	'Check analog value

    IF d  THEN w$ = "@@@ ERROR @@@ Relay 2 (NO) did not open!"+cr$: gosub 1000: GOTO 20					'Error messages and count errors

    IF a < 1018 THEN w$ = "@@@ ERROR @@@ Open Input 4 Analog Value:"+STR$(a)+" too low! (1018..1024)"+cr$: gosub 1000	'Error messages and count errors





20      'Testing Din 5..8 and Dout 1..4 * * * * * * * * * * * * * * * * * * * *

    FOR i=1 TO 4		'Testing D OUT 1..4 (D IN 5..8 offset +4

        IOCTL 100+i, 1		'activate Dout

        DELAY tio		'Wait tio (time io) for output being active

        d = IOSTATE(204+i)	'Check digital state

        IF d = 0 THEN w$ = "@@@ ERROR @@@ Input "+STR$(i+4)+" is inactive (5V) but should be active (low)! Maybe not connected to Dout "+STR$(i+4)+cr$: gosub 1000 'Error messages and count errors

    NEXT i



    FOR i=1 TO 4		'Testing D OUT 1..4 (D IN 5..8 offset +4

        IOCTL 100+i, 0		'deactivate Dout

        DELAY tio		'Wait tio (time io) for output being inactive

        d = IOSTATE(204+i)	'Check digital state

        IF d THEN w$ = "@@@ ERROR @@@ Input "+STR$(i+4)+" is active (low) but should be inactive (5V)!"+cr$: gosub 1000	'Error messages and count errors

    NEXT i



30  IF e = 0 THEN GOTO 40

    w$ = cr$+cr$+"@@@@@@@@@@@@@@@"+cr$: gosub 2000

    w$ = "FAILURE !!!"+STR$(e)+" ERRORS FOUND! CHECK TESTER AND DEVICE! TEST STARTS AUTOMATICALLY IN 5 SECONDS"+cr$: gosub 2000

    w$ = "@@@@@@@@@@@@@@@"+cr$: gosub 2000

35  READ 1, s$				'Read RS-232 input buffer (pin2 and 3 are crossed so all reporting in buffer)

    IF LEN(s$)>0 THEN DELAY 100: GOTO 35	'Repeat until buffer empty (because buffer is not emptied upon close

    CLOSE 1

    DELAY 5000

    e=0

    GOTO 1



1000	  ' write error message to console and syslog, increment error counter

    e=e+1			' count errors

2000 	  ' same without inc of error count

    WRITE 1, w$, 0		' message to console

    SYSLOG w$ 	 		' syslog also 

    return





  ' change programm name to default == empty

40  OPEN "STP:0" AS 3 

    READ 3,set$ 

    midset set$, 101, 1, 0	' set either index of string =0 (len==0) or termination char at first location - both should make this empty

    midset set$, 34, 1, 0					' set RS485 MODE

    Write 3,set$,256

    CLOSE 3 



    w$ = cr$+cr$+"SUCCESS !!!"+cr$: gosub 2000

    w$ = "SUCCESS !!! Test completed OK!"+cr$: gosub 2000

    CLOSE 1



 

'end of program * * * * * * * * * * * * * * * * * * * *

END

